﻿#include "ProjectConfig.h"

#ifdef WIN
const char* PATH_SPLIT_TAG = "\\";
#else // Linux
const char* PATH_SPLIT_TAG = "/";
#endif // Linux

ProjectConfig *ProjectConfig::GetInstance()
{
	static ProjectConfig *instance = new ProjectConfig();
	return instance;
}

ProjectConfig::ProjectConfig()
{

}

void ProjectConfig::Init(const std::string& root)
{
	std::string sub = root.substr(0, root.find_last_of(PATH_SPLIT_TAG));
	sub = sub.substr(0, sub.find_last_of(PATH_SPLIT_TAG));
	res_.root_dir = sub;
	res_.conf_dir = sub + PATH_SPLIT_TAG + "conf" + PATH_SPLIT_TAG;
	res_.tool_dir = sub + PATH_SPLIT_TAG + "tools" + PATH_SPLIT_TAG;
	res_.plugin_dir = sub + PATH_SPLIT_TAG + "plugins" + PATH_SPLIT_TAG;
}

std::string ProjectConfig::GetConfigFile(const std::string& file)
{
	return res_.conf_dir + file;
}

std::string ProjectConfig::GetToolFile(const std::string& file)
{
	return res_.tool_dir + file;
}

std::string ProjectConfig::GetPluginFile(const std::string& file)
{
	return res_.plugin_dir + file;
}
