﻿// MIT License
//
// Copyright (c) 2021~2022 [coder4869](https://github.com/coder4869)
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in all
// copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.

#ifndef QLANDSCAPEDB_DIALOG_H
#define QLANDSCAPEDB_DIALOG_H

#include <CCoreKit/CCKDefines.h>

#include <QDialog>

namespace Ui {
class QLandscapeDBDialog;
}
class QTreeWidgetItem;
class QListWidget;
class QListWidgetItem;
class AirportListParser;

class QLandscapeDBDialog : public QDialog
{
    Q_OBJECT

public:
    explicit QLandscapeDBDialog(QWidget *parent = nullptr);
    ~QLandscapeDBDialog();

    void InitData();

Q_SIGNALS:

public Q_SLOTS:
    void OnAddAirport(bool clicked);
    void OnDelAirport(bool clicked);
    void OnExportAirports(bool clicked);
    void OnItemClicked(QListWidgetItem* item);

private:
    Ui::QLandscapeDBDialog *ui;
    std::shared_ptr<AirportListParser> parser_;
    
    void ListWidgetSortAndTextCenter(QListWidget* widget);
    void ListWidgetUpdateSelection(QListWidget* widget, QListWidgetItem *selected);
    void ListWidgetCancelSelection(QListWidget* widget);
    virtual void resizeEvent(QResizeEvent* event) override;
};

#endif // QLANDSCAPEDB_DIALOG_H
